package addressbook;

import org.w3c.dom.Document;

import com.neocore.httpclient.XMLEncoder;

public class UpdateAddressbookBean {

	ConnectXprioriBean xcon = null; // ConnectXprioriBean饹

	/**
	 * 󥹥ȥ饯 ConnectXprioriBean饹ƤӽФXprioriȤ³Ω
	 */
	public UpdateAddressbookBean() {
		// XprioriȤ³Ω
		xcon = new ConnectXprioriBean();
	}
	
	/**
	 * ƥ
	 * @param item
	 * @return
	 */
	public String insertItem(ItemBean item) {
		// XprioriϿƤǸitemǤꤹXPath
		String insertXPath = "/ND/address_book/item[last()]";

		//ǸitemǤ¸ߤ뤫å
		String tmpItem_xml = xcon.query(insertXPath);
		Document doc = AddressbookUtils.loadXMLFromString(tmpItem_xml);

		// itemǤ¸ߤʤȤaddress_bookǤκǽλǤǤ
		// dummyǤоǤȤ
		if(doc.getElementsByTagName("item").item(0) == null){
			insertXPath = "/ND/address_book/dummy[last()]";
		}

		// itemXMLꡢXML
		String ret = xcon.insert(insertXPath, item.getItemXML());
		return ret;
	}

	/**
	 * ƥ򹹿
	 * @param item
	 * @return
	 */
	public String modifyItem(ItemBean item) {
		
		// ԽtelǤ¸ߤ뤫ɤå
		String countTelNodeXpath = "count(/ND/address_book/item[@id = " + AddressbookUtils.getXpathConcat(XMLEncoder.xmlEncode(item.getID())) + "]/tel)";
		//ǸitemǤ¸ߤ뤫å
		String telNodeNum_xml = xcon.query(countTelNodeXpath);
		Document doc = AddressbookUtils.loadXMLFromString(telNodeNum_xml);
		//	telǤʤ϶telǤԽ¹Ԥ
		if(AddressbookUtils.getQResultInteger(doc) == 0 ){
			//	telǤ
			xcon.insert("/ND/address_book/item[@id = " + AddressbookUtils.getXpathConcat(XMLEncoder.xmlEncode(item.getID())) + "]/address", "<tel></tel>");
		}
		// ItemBeanidƱID°ͤitemǤXPath
		String modifyXPath = "/ND/address_book/item[@id = " + AddressbookUtils.getXpathConcat(XMLEncoder.xmlEncode(item.getID())) + "]";
		// itemԽXMLꡢXPathǻꤷ¸ΥƥXML֤
		String ret = xcon.modify(modifyXPath, item.getItemXML());

		return ret;
	} 

	/**
	 * ƥ
	 * @param item
	 * @return
	 */
	public String deleteItem(ItemBean item) {
		// ItemBeanidƱID°ͤitemǤXPath
		String deleteXPath = "/ND/address_book/item[@id = " + AddressbookUtils.getXpathConcat(XMLEncoder.xmlEncode(item.getID())) + "]";
		// XPathǻꤷ¸ΥƥXML
		String ret = xcon.delete(deleteXPath);
		return ret;
	} 
	
	/**
	 * Ȥ
	 * 
	 */
	public void logout() {
		xcon.logout();
	}	

	
}
